#define ASM
#define STANDALONE
#include <hardware.h>

#define UART_SPEED 460800

/***
        vs1053a-uartin
        - currently assumes MP3
        - receive stream data from UART, route it to stream buffer

        NOTE: RX pin should be forced high until the code has been loaded,
        	otherwise a reception of 0xef will cause the chip to jump into
        	monitor during the boot.
        Currently the boot image disables RX interrupt, so it is a bit more
        robust.
**/


        .sect code,init
        .org 0x50

        .import _rommain,__stack,_applAddr

#if 1
        //ldc 0xe430,a0
        //ldc 0xe388,a0
        ldc 0xc430,a0 //4.5x 12.288MHz XTALI
        ldc SCI_CLOCKF,i7
        stx a0,(i7)
#endif

#if 0
        //Support external hardware to enable RX
        //uart rx interrupt has been replaced by the time we run...
        ldc GPIO_DDR,i7
        ldc (1<<3),a0
        stx a0,(i7)+(GPIO_ODATA-GPIO_DDR)
        stx a0,(i7)	//drive GPIO3 high after boot
#endif

        .import _ApplAddr
        ldc _ApplAddr,a0
        ldc SCI_AIADDR,i5
        stx a0,(i5)
        ldc _applAddr,i5
        stx a0,(i5)

        ldc 0x21a1,le
        ldc 1,lc
        ldc L21a1,ls
        j _rommain
        ldc __stack,i6
L21a1:
        //ldc 9600/10,a0
        //ldc 115200/10,a0	//uartByteSpeed
        ldc 100,lc
        ldc 0x29c1,le	//IsMP23Header+0x40
        ldc L29c1,ls

        j 0x21a2
        ldc (UART_SPEED/10),a0	//uartByteSpeed	-- read from AICTRL0?

        .import _pcm_point
        ldc _pcm_point,i7	//20131213 pcm_point = 0;
        stx a0,(i7)


        .import _rommain
        j _rommain
        ldc __stack,i6
L29c1:
        //from 0x29c2=IsMP23Header+0x40
        //Note: B is required to check "OggS"
        ldc 100,lc
#if 0
        // mpeg2.5 only valid with mp3
        // Ignore bits 0:CRC off/on 1:layer-lsb 3:MPEG-lsb
        // 2:III/reserved vs I/II, 4:MPEG2.5 vs MPEG1.0/2.0
        ldc 0xfff4,a0
        and d1,a0,a0
        ldc 0xffe4,a1	//if bit 4 is 0 (MPEG2.5), bit 2 can not be 1 (I or II)
        sub a0,a1,a0
        nop
        jzs 0x2b14	//return FALSE;
        ldc 100,lc
#endif
        ldx (i6)+1,null
        stx lr0,(i6)+1
        .import _MyCheckTag
        call _MyCheckTag
        stx d0,(i6)	; sty d1,(i6)
        ldx (i6)-1,d0	; ldy (i6),d1
        ldx (i6)-1,lr0

        j 0x29c2
        sub D,B,B




#if 0
        //TODO: for 48kHz rate use the 15/16 resampler
        
#endif





#if 1
        .import _stream_rd_pointer
        .sect data_y,init_y
_stream_wr_odd:
        .zero 1

        .sect code,code
UartRx:
        stx lr0,(I6)+1	; sty i7,(i6)
        stx mr0,(i6)+1	; sty lr1,(i6)
        stx a0,(i6)+1	; sty b0,(i6)
        stx c0,(i6)+1	; sty i0,(i6)
        stx i5,(i6)	; sty i4,(i6)
        ldc 0x200,mr0

        ldc INT_GLOB_ENA,i5
        .import _stream_wr_pointer,_stream_rd_pointer
        ldc _stream_wr_pointer,i7
        stx i5,(i5)	; ldy (i7),i4	//stream_wr_pointer
        ldc _stream_wr_odd,i7
        ldx (i4),c0	; ldy (i7),b0
        xor b0,ones,b0
        sty b0,(i7)	//stream_wr_odd = 1-stream_wr_odd;
        ldc 0x8000-1+STREAM_BUFFER_SZ,i5	//modulo 1024
        jzs $0
        ldc UART_DATA,i0

        and c0,null,c0	; ldx (i0)+(UART_DATAH-UART_DATA),null
        ldc 0,i5	//do not advance yet
$0:
        LDX (i0),a0	//UART_DATA or UART_DATAH
        or c0,a0,c0	//*stream_wr_pointer |= USEX(UART_DATA);
        stx c0,(i4)*

        ldc _stream_wr_pointer,i7
        sty i4,(i7)	//save stream_wr_pointer

        ldx (i6)-1,i5	; ldy (i6),i4
        ldx (i6)-1,c0	; ldy (i6),i0
        ldx (i6)-1,a0	; ldy (i6),b0
        //interrupts already enabled!
        ldx (i6)-1,mr0	; ldy (i6),lr0	//mr0, lr1
        jr
        ldx (i6)-1,lr0	; ldy (i6),i7	//lr0, i7

        .sect code,abs
        .org 0x25
        jmpi UartRx,(i6)+1
#endif


#if 0
        .sect code,CheckTagVector
        .org 0x36
        .import _MyCheckTag
        jmpi _MyCheckTag
#endif

#if 1
        .sect code,Swap16
        .export _Swap16
_Swap16:
        ldc 8,a0
        and b1,null,b1;	stx b1,(i6)
        ashl b,a0,b
        jr
        or b1,b0,a0;	ldx (i6)-1,b1
#endif

        .end
