#define ASM
#define STANDALONE
#include <hardware.h>

#define UART_SPEED 460800

/***
        vs1063a-uartin
        - currently assumes MP3
        - receive stream data from UART, route it to stream buffer

        NOTE: RX pin should be forced high until the code has been loaded,
        	otherwise a reception of 0xef will cause the chip to jump into
        	monitor during the boot.
        Currently the boot image disables RX interrupt, so it is a bit more
        robust.
**/


        .sect code,init
        .org 0x50

        .import _rommain,__stack,_applAddr

#if 1
        //ldc 0xe430,a0
        //ldc 0xe388,a0
        ldc 0xc430,a0 //4.5x 12.288MHz XTALI
        ldc SCI_CLOCKF,i7
        stx a0,(i7)
#endif

#if 0
        //Support external hardware to enable RX
        ldc GPIO_DDR,i7
        ldc (1<<3),a0
        stx a0,(i7)+(GPIO_ODATA-GPIO_DDR)
        stx a0,(i7)	//drive GPIO3 high after boot
#endif

#if 0
#define TUNE_FREQ 1000
        ldc TIMER_T0L,i7
        ldc lo(12288000*4/TUNE_FREQ),a0
        stx a0,(i7)+(TIMER_T0H-TIMER_T0L)
        ldc hi(12288000*4/TUNE_FREQ),a0
        stx a0,(i7)+(TIMER_ENABLE-TIMER_T0H)
        ldc 1,a0
        stx a0,(i7)+(TIMER_CONFIG-TIMER_ENABLE)
        stx a0,(i7)
//(1<<INT_EN_TIM0)
#endif

        .import _ApplAddr
        ldc _ApplAddr,a0
        ldc SCI_AIADDR,i5
        stx a0,(i5)
        ldc _applAddr,i5
        stx a0,(i5)
        //ldc 9600/10,a0
        //ldc 115200/10,a0	//uartByteSpeed
        ldc (UART_SPEED/10),a0	//uartByteSpeed	-- read from AICTRL0?
        j _rommain+1
        ldc __stack,i6


#if 0
        //TODO: for 48kHz rate use the 15/16 resampler
        
#endif



#if 1
        .import _stream_rd_pointer
        .sect data_y,init_y
_stream_wr_odd:
        .zero 1

        .sect code,code
UartRx:
        stx lr0,(I6)+1	; sty i7,(i6)
        stx mr0,(i6)+1	; sty lr1,(i6)
        stx a0,(i6)+1	; sty b0,(i6)
        stx c0,(i6)+1	; sty i0,(i6)
        stx i5,(i6)	; sty i4,(i6)
        ldc 0x200,mr0

        ldc INT_GLOB_ENA,i5
        .import _stream_wr_pointer,_stream_rd_pointer
        ldc _stream_wr_pointer,i7
        stx i5,(i5)	; ldy (i7),i4	//stream_wr_pointer
        ldc _stream_wr_odd,i7
        ldx (i4),c0	; ldy (i7),b0
        xor b0,ones,b0
        sty b0,(i7)	//stream_wr_odd = 1-stream_wr_odd;
        ldc 0x8000-1+STREAM_BUFFER_SZ,i5	//modulo 1024
        jzs $0
        ldc UART_DATA,i0

        and c0,null,c0	; ldx (i0)+(UART_DATAH-UART_DATA),null
        ldc 0,i5	//do not advance yet
$0:
        LDX (i0),a0	//UART_DATA or UART_DATAH
        or c0,a0,c0	//*stream_wr_pointer |= USEX(UART_DATA);
        stx c0,(i4)*

        ldc _stream_wr_pointer,i7
        sty i4,(i7)	//save stream_wr_pointer

        ldx (i6)-1,i5	; ldy (i6),i4
        ldx (i6)-1,c0	; ldy (i6),i0
        ldx (i6)-1,a0	; ldy (i6),b0
        //interrupts already enabled!
        ldx (i6)-1,mr0	; ldy (i6),lr0	//mr0, lr1
        jr
        ldx (i6)-1,lr0	; ldy (i6),i7	//lr0, i7

        .sect code,abs
        .org 0x25
        jmpi UartRx,(i6)+1
#endif


#if 1
        .sect code,CheckTagVector
        .org 0x36
        .import _MyCheckTag
        jmpi _MyCheckTag
#endif

        .end
